#include "pgraph.h"

const int cycles = 5;
const double res = 0.001;
const double frec = 1.5;
const int size = 175;
const int sizeX = 320;
const int sizeY = 180;
const int nframes = 63;
const int TWO_PI = 6.28318530717959;

int main()
{
	double phase = 0.0;
	image *img = create_image(2 * sizeX, 2 * sizeY);
	char filename[14];
	for (int i = 1; i <= nframes; i++)
	{
		fill_all(img, BLACK);
		for (double t = 0.0; t < cycles * TWO_PI; t += res)
		{
			double x = sin(t);
			double y = sin(t * frec + phase);
			set_color(img, sizeX + round(x * size + 0.5), 
					  sizeY + round(y * size + 0.5), GREEN);
		}			
		sprintf(filename, "results\\%02d.bmp", i);
		save_to_file(img, filename);
		phase += 0.1;	
	}
	free(img);
	return 0;
}
